# -*- coding: utf-8 -*-
import optparse
import sys

import main
import defaults

# Ignore any exceptions writing to stdout using print statements
class SafeStdout:
    def __init__(self):
        self.stdout = sys.stdout

    def fileno(self):
        return self.stdout.fileno()

    def write(self, data):
        try:
            self.stdout.write(data)
        except:
            pass

sys.stdout = SafeStdout()


def profile_me(func):
    import tempfile, hotshot, hotshot.stats, os.path
    pname = os.path.join(tempfile.gettempdir(), 'GNOME_SUDOKU_HOTSHOT_PROFILE')
    prof = hotshot.Profile(pname)
    prof.runcall(func)
    stats = hotshot.stats.load(pname)
    stats.strip_dirs()
    stats.sort_stats('time', 'calls').print_stats()


def start_game ():
    parser = optparse.OptionParser(
        version = defaults.VERSION,
        option_list = [
            optparse.make_option("-d", const=True, action="store_const",
                dest="debug", help="Print debug information",
                default=False),
            optparse.make_option("-p", const=True, action="store_const",
                dest="profile", help="Profile gnome-sudoku",
                default=False)])

    options, args = parser.parse_args()

    if options.profile:
        print 'Profiling GNOME Sudoku'
        profile_me(lambda: main.start_game(options.debug))
    else:
        main.start_game(options.debug)
